# ginbee-dbbackup

DBバックアップサービスのクライアント。

## 動作環境

* Ubuntu(Linux全般)
* Ruby1.9.3以降

## 前提条件

以下の条件を確認してください。

* `ginbee-dbbackup.gem` をインストールし、`postgres`ユーザで実行すること
  * `pg_baseback`が動作することを確認
* `gzip`コマンドが動作すること
* `curl`コマンドが動作すること

## 設定

設定ファイルの設定例は`config.sample.yml`を参考に設定する。
`--work_dir`に指定したディレクトリ以下に`config.yml`として配置する。

## アップロード間隔

* BASEファイル
  * 10日に一度だけアップロードする
* WALファイル
  * 10分に一度だけ新規ファイルがあればアップロードする

## コマンド仕様

```zsh
$ ginbee-dbbackup --work_dir=/var/lib/postgresql/.ginbee-dbbackup/
```

`--work_dir` を指定しない場合は`$HOME/.ginbee-dbbackup`がデフォルト

```zsh
$ ginbee-dbbackup-downlaod --work_dir=/var/lib/postgresql/.ginbee-dbbackup/
```

アップロードしたDBバックアップファイルをカレントディレクトリにダウンロードする

## サーバへの設定方法

rootのcronに以下の設定を追加

```
*/10 * * * * sudo -u postgres ginbee-dbbackup --work_dir=/var/lib/postgresql/.ginbee-dbbackup/
```

mis_uploader用にvisudoでsudoersを設定(例)

```
postgres ALL=(orca) NOPASSWD: /usr/lib/jma-receipt/patch-lib/scripts/tools/run_mis.sh
postgres ALL= NOPASSWD: /bin/chown orca /var/lib/postgresql/.ginbee-dbbackup/mis
postgres ALL= NOPASSWD: /bin/chown -R postgres /var/lib/postgresql/.ginbee-dbbackup/mis
```

## License

The gem is available as open source under the terms of the [MIT License](http://opensource.org/licenses/MIT).
