# encoding: utf-8

require_relative "../lib/ginbee/dbbackup"
require "optparse"
require 'yaml'

opt = OptionParser.new
opt.on('--work_dir VAL'){|v| Ginbee::Dbbackup.conf['work_dir'] = v }
opt.parse!(ARGV)

if not Ginbee::Dbbackup.conf['work_dir']
  work_dir = File.join(ENV['HOME'], ".ginbee-dbbackup")
  FileUtils.mkdir_p(work_dir)
  Ginbee::Dbbackup.conf['work_dir'] = work_dir
end

Ginbee::Dbbackup.conf.merge!(YAML.load_file(File.join(Ginbee::Dbbackup.conf['work_dir'], "config.yml")))

%w(cacert cert cert_key sms_host work_dir).each do |key|
  if not Ginbee::Dbbackup.conf[key]
    $stderr.puts "config: #{key} is not defined."
    exit 1
  end
  if !%(sms_host).include?(key) && !File.exists?(Ginbee::Dbbackup.conf[key])
    $stderr.puts "config: #{key} file not exists."
    exit 1
  end
end

if Ginbee::Dbbackup.conf['dbbackup_api_key'] && !/\A[a-f0-9]+\z/m.match(Ginbee::Dbbackup.conf['dbbackup_api_key'])
  $stderr.puts 'config: dbbackup_api_key is invalid format'
  exit 1
end
begin
  Ginbee::Dbbackup::Downloader.new.run
rescue => e
  $stderr.puts e.message
  Ginbee::Dbbackup.logger.error(e.message)
  e.backtrace.each do |line|
    Ginbee::Dbbackup.logger.error(line)
  end
  exit 1
end
